diff --git a/plugins/imtcp/imtcp.c b/plugins/imtcp/imtcp.c
index 45674db334..7a853bc2c9 100644
--- a/plugins/imtcp/imtcp.c
+++ b/plugins/imtcp/imtcp.c
@@ -103,6 +103,7 @@ static struct configSettings_s {
 	int bPreserveCase;
 	uchar *gnutlsPriorityString;
 	uchar *pszStrmDrvrAuthMode;
+	uchar *pszStrmDrvrPermitExpiredCerts;
 	uchar *pszInputName;
 	uchar *pszBindRuleset;
 	uchar *lstnIP;			/* which IP we should listen on? */
@@ -144,6 +145,7 @@ struct modConfData_s {
 	uchar *gnutlsPriorityString;
 	uchar *pszStrmDrvrName; /* stream driver to use */
 	uchar *pszStrmDrvrAuthMode; /* authentication mode to use */
+	uchar *pszStrmDrvrPermitExpiredCerts; /* control how to handly expired certificates */
 	struct cnfarray *permittedPeers;
 	sbool configSetViaV2Method;
 	sbool bPreserveCase; /* preserve case of fromhost; true by default */
@@ -166,6 +168,7 @@ static struct cnfparamdescr modpdescr[] = {
 	{ "maxlisteners", eCmdHdlrPositiveInt, 0 },
 	{ "streamdriver.mode", eCmdHdlrNonNegInt, 0 },
 	{ "streamdriver.authmode", eCmdHdlrString, 0 },
+	{ "streamdriver.permitexpiredcerts", eCmdHdlrString, 0 },
 	{ "streamdriver.name", eCmdHdlrString, 0 },
 	{ "permittedpeer", eCmdHdlrArray, 0 },
 	{ "keepalive", eCmdHdlrBinary, 0 },
@@ -378,6 +381,9 @@ addListner(modConfData_t *modConf, instanceConf_t *inst)
 		if(modConf->pszStrmDrvrAuthMode != NULL) {
 			CHKiRet(tcpsrv.SetDrvrAuthMode(pOurTcpsrv, modConf->pszStrmDrvrAuthMode));
 		}
+		if(modConf->pszStrmDrvrPermitExpiredCerts != NULL) {
+			CHKiRet(tcpsrv.SetDrvrPermitExpiredCerts(pOurTcpsrv, modConf->pszStrmDrvrPermitExpiredCerts));
+		}
 		if(pPermPeersRoot != NULL) {
 			CHKiRet(tcpsrv.SetDrvrPermPeers(pOurTcpsrv, pPermPeersRoot));
 		}
@@ -485,6 +491,7 @@ CODESTARTbeginCnfLoad
 	loadModConf->gnutlsPriorityString = NULL;
 	loadModConf->pszStrmDrvrName = NULL;
 	loadModConf->pszStrmDrvrAuthMode = NULL;
+	loadModConf->pszStrmDrvrPermitExpiredCerts = NULL;
 	loadModConf->permittedPeers = NULL;
 	loadModConf->configSetViaV2Method = 0;
 	loadModConf->bPreserveCase = 1; /* default to true */
@@ -554,6 +561,8 @@ CODESTARTsetModCnf
 			loadModConf->iStrmDrvrMode = (int) pvals[i].val.d.n;
 		} else if(!strcmp(modpblk.descr[i].name, "streamdriver.authmode")) {
 			loadModConf->pszStrmDrvrAuthMode = (uchar*)es_str2cstr(pvals[i].val.d.estr, NULL);
+		} else if(!strcmp(modpblk.descr[i].name, "streamdriver.permitexpiredcerts")) {
+			loadModConf->pszStrmDrvrPermitExpiredCerts = (uchar*)es_str2cstr(pvals[i].val.d.estr, NULL);
 		} else if(!strcmp(modpblk.descr[i].name, "streamdriver.name")) {
 			loadModConf->pszStrmDrvrName = (uchar*)es_str2cstr(pvals[i].val.d.estr, NULL);
 		} else if(!strcmp(modpblk.descr[i].name, "permittedpeer")) {
@@ -667,6 +676,7 @@ BEGINfreeCnf
 CODESTARTfreeCnf
 	free(pModConf->pszStrmDrvrName);
 	free(pModConf->pszStrmDrvrAuthMode);
+	free(pModConf->pszStrmDrvrPermitExpiredCerts);
 	if(pModConf->permittedPeers != NULL) {
 		cnfarrayContentDestruct(pModConf->permittedPeers);
 		free(pModConf->permittedPeers);
diff --git a/runtime/netstrm.c b/runtime/netstrm.c
index 94351725c0..e1df83edee 100644
--- a/runtime/netstrm.c
+++ b/runtime/netstrm.c
@@ -200,6 +200,17 @@ SetDrvrAuthMode(netstrm_t *pThis, uchar *mode)
 }
 
 
+/* set the driver permitexpiredcerts mode -- alorbach, 2018-12-20
+ */
+static rsRetVal
+SetDrvrPermitExpiredCerts(netstrm_t *pThis, uchar *mode)
+{
+	DEFiRet;
+	ISOBJ_TYPE_assert(pThis, netstrm);
+	iRet = pThis->Drvr.SetPermitExpiredCerts(pThis->pDrvrData, mode);
+	RETiRet;
+}
+
 /* set the driver's permitted peers -- rgerhards, 2008-05-19 */
 static rsRetVal
 SetDrvrPermPeers(netstrm_t *pThis, permittedPeers_t *pPermPeers)
@@ -385,6 +396,7 @@ CODESTARTobjQueryInterface(netstrm)
 	pIf->GetRemAddr = GetRemAddr;
 	pIf->SetDrvrMode = SetDrvrMode;
 	pIf->SetDrvrAuthMode = SetDrvrAuthMode;
+	pIf->SetDrvrPermitExpiredCerts = SetDrvrPermitExpiredCerts;
 	pIf->SetDrvrPermPeers = SetDrvrPermPeers;
 	pIf->CheckConnection = CheckConnection;
 	pIf->GetSock = GetSock;
diff --git a/runtime/netstrm.h b/runtime/netstrm.h
index 367a025325..113585d0a5 100644
--- a/runtime/netstrm.h
+++ b/runtime/netstrm.h
@@ -50,6 +50,7 @@ BEGINinterface(netstrm) /* name must also be changed in ENDinterface macro! */
 	rsRetVal (*GetRemoteIP)(netstrm_t *pThis, prop_t **ip);
 	rsRetVal (*SetDrvrMode)(netstrm_t *pThis, int iMode);
 	rsRetVal (*SetDrvrAuthMode)(netstrm_t *pThis, uchar*);
+	rsRetVal (*SetDrvrPermitExpiredCerts)(netstrm_t *pThis, uchar*);
 	rsRetVal (*SetDrvrPermPeers)(netstrm_t *pThis, permittedPeers_t*);
 	rsRetVal (*CheckConnection)(netstrm_t *pThis);	/* This is a trick mostly for plain tcp syslog */
 	/* the GetSock() below is a hack to make imgssapi work. In the long term,
diff --git a/runtime/netstrms.c b/runtime/netstrms.c
index 7e36adf3e6..bd6a06bd7f 100644
--- a/runtime/netstrms.c
+++ b/runtime/netstrms.c
@@ -109,6 +109,10 @@ CODESTARTobjDestruct(netstrms)
 		free(pThis->pszDrvrAuthMode);
 		pThis->pszDrvrAuthMode = NULL;
 	}
+	if(pThis->pszDrvrPermitExpiredCerts != NULL) {
+		free(pThis->pszDrvrPermitExpiredCerts);
+		pThis->pszDrvrPermitExpiredCerts = NULL;
+	}
 	if(pThis->pBaseDrvrName != NULL) {
 		free(pThis->pBaseDrvrName);
 		pThis->pBaseDrvrName = NULL;
@@ -186,6 +190,8 @@ SetDrvrAuthMode(netstrms_t *pThis, uchar *mode)
 finalize_it:
 	RETiRet;
 }
+
+
 /* return the driver auth mode
  * We use non-standard calling conventions because it makes an awful lot
  * of sense here.
@@ -199,6 +205,31 @@ GetDrvrAuthMode(netstrms_t *pThis)
 }
 
 
+/* return the driver permitexpiredcerts mode
+ * We use non-standard calling conventions because it makes an awful lot
+ * of sense here.
+ * alorbach, 2018-12-21
+ */
+static uchar*
+GetDrvrPermitExpiredCerts(netstrms_t *pThis)
+{
+	ISOBJ_TYPE_assert(pThis, netstrms);
+	return pThis->pszDrvrPermitExpiredCerts;
+}
+
+/* set the driver permitexpiredcerts mode -- alorbach, 2018-12-20
+ */
+static rsRetVal
+SetDrvrPermitExpiredCerts(netstrms_t *pThis, uchar *mode)
+{
+	DEFiRet;
+	ISOBJ_TYPE_assert(pThis, netstrms);
+	CHKmalloc(pThis->pszDrvrPermitExpiredCerts = (uchar*)strdup((char*)mode));
+finalize_it:
+	RETiRet;
+}
+
+
 /* Set the priorityString for GnuTLS
  * PascalWithopf 2017-08-16
  */
@@ -267,7 +298,7 @@ CreateStrm(netstrms_t *pThis, netstrm_t **ppStrm)
 	 */
 	memcpy(&pStrm->Drvr, &pThis->Drvr, sizeof(pThis->Drvr));
 	pStrm->pNS = pThis;
-	
+
 	*ppStrm = pStrm;
 
 finalize_it:
@@ -300,6 +331,8 @@ CODESTARTobjQueryInterface(netstrms)
 	pIf->GetDrvrMode = GetDrvrMode;
 	pIf->SetDrvrAuthMode = SetDrvrAuthMode;
 	pIf->GetDrvrAuthMode = GetDrvrAuthMode;
+	pIf->SetDrvrPermitExpiredCerts = SetDrvrPermitExpiredCerts;
+	pIf->GetDrvrPermitExpiredCerts = GetDrvrPermitExpiredCerts;
 	pIf->SetDrvrGnutlsPriorityString = SetDrvrGnutlsPriorityString;
 	pIf->GetDrvrGnutlsPriorityString = GetDrvrGnutlsPriorityString;
 	pIf->SetDrvrPermPeers = SetDrvrPermPeers;
diff --git a/runtime/netstrms.h b/runtime/netstrms.h
index 87d649a383..440beb20c9 100644
--- a/runtime/netstrms.h
+++ b/runtime/netstrms.h
@@ -33,6 +33,7 @@ struct netstrms_s {
 	uchar *pDrvrName;	/**< full base driver name (set when driver is loaded) */
 	int iDrvrMode;		/**< current default driver mode */
 	uchar *pszDrvrAuthMode;	/**< current driver authentication mode */
+	uchar *pszDrvrPermitExpiredCerts;/**< current driver setting for handlign expired certs */
 	uchar *gnutlsPriorityString; /**< priorityString for connection */
 	permittedPeers_t *pPermPeers;/**< current driver's permitted peers */
 
@@ -49,9 +50,11 @@ BEGINinterface(netstrms) /* name must also be changed in ENDinterface macro! */
 	rsRetVal (*SetDrvrName)(netstrms_t *pThis, uchar *pszName);
 	rsRetVal (*SetDrvrMode)(netstrms_t *pThis, int iMode);
 	rsRetVal (*SetDrvrAuthMode)(netstrms_t *pThis, uchar*);
+	rsRetVal (*SetDrvrPermitExpiredCerts)(netstrms_t *pThis, uchar*);
 	rsRetVal (*SetDrvrPermPeers)(netstrms_t *pThis, permittedPeers_t*);
 	int      (*GetDrvrMode)(netstrms_t *pThis);
 	uchar*   (*GetDrvrAuthMode)(netstrms_t *pThis);
+	uchar*   (*GetDrvrPermitExpiredCerts)(netstrms_t *pThis);
 	permittedPeers_t* (*GetDrvrPermPeers)(netstrms_t *pThis);
 	rsRetVal (*SetDrvrGnutlsPriorityString)(netstrms_t *pThis, uchar*);
 	uchar*   (*GetDrvrGnutlsPriorityString)(netstrms_t *pThis);
diff --git a/runtime/nsd.h b/runtime/nsd.h
index 84d42afae1..eab53ad6ae 100644
--- a/runtime/nsd.h
+++ b/runtime/nsd.h
@@ -60,6 +60,7 @@ BEGINinterface(nsd) /* name must also be changed in ENDinterface macro! */
 	rsRetVal (*GetRemoteIP)(nsd_t *pThis, prop_t **ip);
 	rsRetVal (*SetMode)(nsd_t *pThis, int mode); /* sets a driver specific mode - see driver doc for details */
 	rsRetVal (*SetAuthMode)(nsd_t *pThis, uchar*); /* sets a driver specific mode - see driver doc for details */
+	rsRetVal (*SetPermitExpiredCerts)(nsd_t *pThis, uchar*); /* sets a driver specific permitexpiredcerts mode */
 	rsRetVal (*SetPermPeers)(nsd_t *pThis, permittedPeers_t*); /* sets driver permitted peers for auth needs */
 	rsRetVal (*CheckConnection)(nsd_t *pThis);	/* This is a trick mostly for plain tcp syslog */
 	rsRetVal (*GetSock)(nsd_t *pThis, int *pSock);
diff --git a/runtime/nsd_gtls.c b/runtime/nsd_gtls.c
index 3b388cc113..e0fce1325d 100644
--- a/runtime/nsd_gtls.c
+++ b/runtime/nsd_gtls.c
@@ -1047,6 +1047,8 @@ gtlsChkPeerCertValidity(nsd_gtls_t *pThis)
 	unsigned i;
 	time_t ttCert;
 	time_t ttNow;
+	sbool bAbort = RSFALSE;
+	int iAbortCode = RS_RET_OK;
 
 	ISOBJ_TYPE_assert(pThis, nsd_gtls);
 
@@ -1062,26 +1064,51 @@ gtlsChkPeerCertValidity(nsd_gtls_t *pThis)
 	CHKgnutls(gnutls_certificate_verify_peers2(pThis->sess, &stateCert));
 
 	if(stateCert & GNUTLS_CERT_INVALID) {
+		/* Default abort code */
+		iAbortCode = RS_RET_CERT_INVALID;
+
 		/* provide error details if we have them */
-		if(stateCert & GNUTLS_CERT_SIGNER_NOT_FOUND) {
+		if (stateCert & GNUTLS_CERT_EXPIRED ) {
+			dbgprintf("GnuTLS returned GNUTLS_CERT_EXPIRED, handling mode %d ...\n",
+				pThis->permitExpiredCerts);
+			/* Handle expired certs */
+			if (pThis->permitExpiredCerts == GTLS_EXPIRED_DENY) {
+				bAbort = RSTRUE;
+				iAbortCode = RS_RET_CERT_EXPIRED;
+			} else if (pThis->permitExpiredCerts == GTLS_EXPIRED_WARN) {
+				LogMsg(0, RS_RET_NO_ERRCODE, LOG_WARNING,
+					"Warning, certificate expired but expired certs are permitted");
+			} else {
+				dbgprintf("GnuTLS returned GNUTLS_CERT_EXPIRED, but expired certs are permitted.\n");
+			}
+			pszErrCause = "certificate expired";
+		} else if(stateCert & GNUTLS_CERT_SIGNER_NOT_FOUND) {
 			pszErrCause = "signer not found";
+			bAbort = RSTRUE;
 		} else if(stateCert & GNUTLS_CERT_SIGNER_NOT_CA) {
 			pszErrCause = "signer is not a CA";
+			bAbort = RSTRUE;
 		} else if(stateCert & GNUTLS_CERT_INSECURE_ALGORITHM) {
 			pszErrCause = "insecure algorithm";
+			bAbort = RSTRUE;
 		} else if(stateCert & GNUTLS_CERT_REVOKED) {
 			pszErrCause = "certificate revoked";
+			bAbort = RSTRUE;
 		} else {
 			pszErrCause = "GnuTLS returned no specific reason";
 			dbgprintf("GnuTLS returned no specific reason for GNUTLS_CERT_INVALID, certificate "
 				 "status is %d\n", stateCert);
+			bAbort = RSTRUE;
 		}
+	}
+
+	if (bAbort == RSTRUE) {
 		LogError(0, NO_ERRCODE, "not permitted to talk to peer, certificate invalid: %s",
 				pszErrCause);
 		gtlsGetCertInfo(pThis, &pStr);
 		LogError(0, NO_ERRCODE, "invalid cert info: %s", cstrGetSzStrNoNULL(pStr));
 		cstrDestruct(&pStr);
-		ABORT_FINALIZE(RS_RET_CERT_INVALID);
+		ABORT_FINALIZE(iAbortCode);
 	}
 
 	/* get current time for certificate validation */
@@ -1108,18 +1135,8 @@ gtlsChkPeerCertValidity(nsd_gtls_t *pThis)
 			ABORT_FINALIZE(RS_RET_CERT_NOT_YET_ACTIVE);
 		}
 
-		ttCert = gnutls_x509_crt_get_expiration_time(cert);
-		if(ttCert == -1)
-			ABORT_FINALIZE(RS_RET_TLS_CERT_ERR);
-		else if(ttCert < ttNow) {
-			LogError(0, RS_RET_CERT_EXPIRED, "not permitted to talk to peer: certificate"
-				" %d expired", i);
-			gtlsGetCertInfo(pThis, &pStr);
-			LogError(0, RS_RET_CERT_EXPIRED, "invalid cert info: %s", cstrGetSzStrNoNULL(pStr));
-			cstrDestruct(&pStr);
-			ABORT_FINALIZE(RS_RET_CERT_EXPIRED);
-		}
 		gnutls_x509_crt_deinit(cert);
+
 	}
 
 finalize_it:
@@ -1312,6 +1329,41 @@ SetAuthMode(nsd_t *pNsd, uchar *mode)
 }
 
 
+/* Set the PermitExpiredCerts mode. For us, the following is supported:
+ * on - fail if certificate is expired
+ * off - ignore expired certificates
+ * warn - warn if certificate is expired
+ * alorbach, 2018-12-20
+ */
+static rsRetVal
+SetPermitExpiredCerts(nsd_t *pNsd, uchar *mode)
+{
+	DEFiRet;
+	nsd_gtls_t *pThis = (nsd_gtls_t*) pNsd;
+
+	ISOBJ_TYPE_assert((pThis), nsd_gtls);
+	/* default is set to warn! */
+	if(mode == NULL || !strcasecmp((char*)mode, "warn")) {
+		pThis->permitExpiredCerts = GTLS_EXPIRED_WARN;
+	} else if(!strcasecmp((char*) mode, "off")) {
+		pThis->permitExpiredCerts = GTLS_EXPIRED_DENY;
+	} else if(!strcasecmp((char*) mode, "on")) {
+		pThis->permitExpiredCerts = GTLS_EXPIRED_PERMIT;
+	} else {
+		LogError(0, RS_RET_VALUE_NOT_SUPPORTED, "error: permitexpiredcerts mode '%s' not supported by "
+				"ossl netstream driver", mode);
+		ABORT_FINALIZE(RS_RET_VALUE_NOT_SUPPORTED);
+	}
+
+	dbgprintf("SetPermitExpiredCerts: Set Mode %s/%d\n", mode, pThis->permitExpiredCerts);
+
+/* TODO: clear stored IDs! */
+
+finalize_it:
+	RETiRet;
+}
+
+
 /* Set permitted peers. It is depending on the auth mode if this are
  * fingerprints or names. -- rgerhards, 2008-05-19
  */
@@ -1545,6 +1597,7 @@ AcceptConnReq(nsd_t *pNsd, nsd_t **ppNew)
 	CHKiRet(gtlsInitSession(pNew));
 	gtlsSetTransportPtr(pNew, ((nsd_ptcp_t*) (pNew->pTcp))->sock);
 	pNew->authMode = pThis->authMode;
+	pNew->permitExpiredCerts = pThis->permitExpiredCerts;
 	pNew->pPermPeers = pThis->pPermPeers;
 	pNew->gnutlsPriorityString = pThis->gnutlsPriorityString;
 	/* here is the priorityString set */
@@ -1906,6 +1959,7 @@ CODESTARTobjQueryInterface(nsd_gtls)
 	pIf->SetSock = SetSock;
 	pIf->SetMode = SetMode;
 	pIf->SetAuthMode = SetAuthMode;
+	pIf->SetPermitExpiredCerts = SetPermitExpiredCerts;
 	pIf->SetPermPeers =SetPermPeers;
 	pIf->CheckConnection = CheckConnection;
 	pIf->GetRemoteHName = GetRemoteHName;
diff --git a/runtime/nsd_gtls.h b/runtime/nsd_gtls.h
index 1ca4b206bd..dcb69d395a 100644
--- a/runtime/nsd_gtls.h
+++ b/runtime/nsd_gtls.h
@@ -49,6 +49,11 @@ struct nsd_gtls_s {
 		GTLS_AUTH_CERTVALID = 2,
 		GTLS_AUTH_CERTANON = 3
 	} authMode;
+	enum {
+		GTLS_EXPIRED_PERMIT = 0,
+		GTLS_EXPIRED_DENY = 1,
+		GTLS_EXPIRED_WARN = 2
+	} permitExpiredCerts;
 	gtlsRtryCall_t rtryCall;/**< what must we retry? */
 	int bIsInitiator;	/**< 0 if socket is the server end (listener), 1 if it is the initiator */
 	gnutls_session_t sess;
diff --git a/runtime/nsd_ossl.c b/runtime/nsd_ossl.c
index 6d0c8db9bd..a9404fc463 100644
--- a/runtime/nsd_ossl.c
+++ b/runtime/nsd_ossl.c
@@ -227,6 +227,8 @@ int verify_callback(int status, X509_STORE_CTX *store)
 		int err = X509_STORE_CTX_get_error(store);
 		SSL* ssl = X509_STORE_CTX_get_ex_data(store, SSL_get_ex_data_X509_STORE_CTX_idx());
 		int iVerifyMode = SSL_get_verify_mode(ssl);
+		nsd_ossl_t *pThis = (nsd_ossl_t*) SSL_get_ex_data(ssl, 0);
+		assert(pThis != NULL);
 
 		dbgprintf("verify_callback: Certificate validation failed, Mode (%d)!\n", iVerifyMode);
 
@@ -234,21 +236,41 @@ int verify_callback(int status, X509_STORE_CTX *store)
 		X509_NAME_oneline(RSYSLOG_X509_NAME_oneline(cert), szdbgdata2, sizeof(szdbgdata2));
 
 		if (iVerifyMode != SSL_VERIFY_NONE) {
-			/* TODO: Create setting:
-			*	permitExpiredCerts="on|off|warn"
-			* Log Warning when EXPIRED cert only
-			*/
+			/* Handle expired Certificates **/
 			if (err == X509_V_OK || err == X509_V_ERR_CERT_HAS_EXPIRED) {
-				LogMsg(0, RS_RET_NO_ERRCODE, LOG_WARNING,
-					"Certificate warning at depth: %d \n\t"
-					"issuer  = %s\n\t"
-					"subject = %s\n\t"
-					"err %d:%s",
-					depth, szdbgdata1, szdbgdata2, err, X509_verify_cert_error_string(err));
-
-				/* Set Status to OK*/
-				status = 1;
+				if (pThis->permitExpiredCerts == OSSL_EXPIRED_PERMIT) {
+					dbgprintf("verify_callback: EXPIRED cert but PERMITTED at depth: %d \n\t"
+						"issuer  = %s\n\t"
+						"subject = %s\n\t"
+						"err %d:%s\n", depth, szdbgdata1, szdbgdata2,
+						err, X509_verify_cert_error_string(err));
+
+					/* Set Status to OK*/
+					status = 1;
+				}
+				else if (pThis->permitExpiredCerts == OSSL_EXPIRED_WARN) {
+					LogMsg(0, RS_RET_NO_ERRCODE, LOG_WARNING,
+						"Certificate EXPIRED warning at depth: %d \n\t"
+						"issuer  = %s\n\t"
+						"subject = %s\n\t"
+						"err %d:%s",
+						depth, szdbgdata1, szdbgdata2,
+						err, X509_verify_cert_error_string(err));
+
+					/* Set Status to OK*/
+					status = 1;
+				}
+				else /* also default - if (pThis->permitExpiredCerts == OSSL_EXPIRED_DENY)*/ {
+					LogError(0, RS_RET_NO_ERRCODE,
+						"Certificate EXPIRED at depth: %d \n\t"
+						"issuer  = %s\n\t"
+						"subject = %s\n\t"
+						"err %d:%s",
+						depth, szdbgdata1, szdbgdata2,
+						err, X509_verify_cert_error_string(err));
+				}
 			} else {
+				/* all other error codes cause failure */
 				LogError(0, RS_RET_NO_ERRCODE,
 					"Certificate error at depth: %d \n\t"
 					"issuer  = %s\n\t"
@@ -257,11 +279,15 @@ int verify_callback(int status, X509_STORE_CTX *store)
 					depth, szdbgdata1, szdbgdata2, err, X509_verify_cert_error_string(err));
 			}
 		} else {
+			/* do not verify certs in ANON mode, just log into debug */
 			dbgprintf("verify_callback: Certificate validation DISABLED but Error at depth: %d \n\t"
 				"issuer  = %s\n\t"
 				"subject = %s\n\t"
 				"err %d:%s\n", depth, szdbgdata1, szdbgdata2,
 				err, X509_verify_cert_error_string(err));
+
+			/* Set Status to OK*/
+			status = 1;
 		}
 	}
 
@@ -810,9 +836,19 @@ osslChkPeerCertValidity(nsd_ossl_t *pThis)
 	iVerErr = SSL_get_verify_result(pThis->ssl);
 	if (iVerErr != X509_V_OK) {
 		if (iVerErr == X509_V_ERR_CERT_HAS_EXPIRED) {
-			LogError(0, RS_RET_CERT_EXPIRED, "not permitted to talk to peer: certificate expired: %s",
-				X509_verify_cert_error_string(iVerErr));
-			ABORT_FINALIZE(RS_RET_CERT_EXPIRED);
+			if (pThis->permitExpiredCerts == OSSL_EXPIRED_DENY) {
+				LogError(0, RS_RET_CERT_EXPIRED,
+					"CertValidity check - not permitted to talk to peer: certificate expired: %s",
+					X509_verify_cert_error_string(iVerErr));
+				ABORT_FINALIZE(RS_RET_CERT_EXPIRED);
+			} else if (pThis->permitExpiredCerts == OSSL_EXPIRED_WARN) {
+				LogMsg(0, RS_RET_NO_ERRCODE, LOG_WARNING,
+					"CertValidity check - warning talking to peer: certificate expired: %s",
+					X509_verify_cert_error_string(iVerErr));
+			} else {
+				dbgprintf("osslChkPeerCertValidity: talking to peer: certificate expired: %s",
+					X509_verify_cert_error_string(iVerErr));
+			}/* Else do nothing */
 		} else {
 			LogError(0, RS_RET_CERT_INVALID, "not permitted to talk to peer: "
 				"certificate validation failed: %s", X509_verify_cert_error_string(iVerErr));
@@ -1007,6 +1043,41 @@ SetAuthMode(nsd_t *pNsd, uchar *mode)
 }
 
 
+/* Set the PermitExpiredCerts mode. For us, the following is supported:
+ * on - fail if certificate is expired
+ * off - ignore expired certificates
+ * warn - warn if certificate is expired
+ * alorbach, 2018-12-20
+ */
+static rsRetVal
+SetPermitExpiredCerts(nsd_t *pNsd, uchar *mode)
+{
+	DEFiRet;
+	nsd_ossl_t *pThis = (nsd_ossl_t*) pNsd;
+
+	ISOBJ_TYPE_assert((pThis), nsd_ossl);
+	/* default is set to warn! */
+	if(mode == NULL || !strcasecmp((char*)mode, "warn")) {
+		pThis->permitExpiredCerts = OSSL_EXPIRED_WARN;
+	} else if(!strcasecmp((char*) mode, "off")) {
+		pThis->permitExpiredCerts = OSSL_EXPIRED_DENY;
+	} else if(!strcasecmp((char*) mode, "on")) {
+		pThis->permitExpiredCerts = OSSL_EXPIRED_PERMIT;
+	} else {
+		LogError(0, RS_RET_VALUE_NOT_SUPPORTED, "error: permitexpiredcerts mode '%s' not supported by "
+				"ossl netstream driver", mode);
+		ABORT_FINALIZE(RS_RET_VALUE_NOT_SUPPORTED);
+	}
+
+	dbgprintf("SetPermitExpiredCerts: Set Mode %s/%d\n", mode, pThis->permitExpiredCerts);
+
+/* TODO: clear stored IDs! */
+
+finalize_it:
+	RETiRet;
+}
+
+
 /* Set permitted peers. It is depending on the auth mode if this are
  * fingerprints or names. -- rgerhards, 2008-05-19
  */
@@ -1324,9 +1395,13 @@ AcceptConnReq(nsd_t *pNsd, nsd_t **ppNew)
 
 	/* If we reach this point, we are in TLS mode */
 	pNew->authMode = pThis->authMode;
+	pNew->permitExpiredCerts = pThis->permitExpiredCerts;
 	pNew->pPermPeers = pThis->pPermPeers;
 	CHKiRet(osslInitSession(pNew));
 
+	/* Store nsd_ossl_t* reference in SSL obj */
+	SSL_set_ex_data(pNew->ssl, 0, pThis);
+
 	/* We now do the handshake */
 	CHKiRet(osslHandshakeCheck(pNew));
 
@@ -1532,8 +1607,8 @@ Connect(nsd_t *pNsd, int family, uchar *port, uchar *host, char *device)
 {
 	DEFiRet;
 	DBGPRINTF("openssl: entering Connect family=%d, device=%s\n", family, device);
-	nsd_ossl_t*pThis = (nsd_ossl_t*) pNsd;
-	nsd_ptcp_t *pPtcp = (nsd_ptcp_t*) pThis->pTcp;
+	nsd_ossl_t* pThis = (nsd_ossl_t*) pNsd;
+	nsd_ptcp_t* pPtcp = (nsd_ptcp_t*) pThis->pTcp;
 
 	BIO *conn;
 
@@ -1571,6 +1646,9 @@ BIO_set_nbio( conn, 1 );
 	pThis->sslState = osslClient; /*set Client state */
 	pThis->bHaveSess = 1;
 
+	/* Store nsd_ossl_t* reference in SSL obj */
+	SSL_set_ex_data(pThis->ssl, 0, pThis);
+
 	/* We now do the handshake */
 	iRet = osslHandshakeCheck(pThis);
 finalize_it:
@@ -1621,6 +1699,7 @@ CODESTARTobjQueryInterface(nsd_ossl)
 	pIf->SetSock = SetSock;
 	pIf->SetMode = SetMode;
 	pIf->SetAuthMode = SetAuthMode;
+	pIf->SetPermitExpiredCerts = SetPermitExpiredCerts;
 	pIf->SetPermPeers =SetPermPeers;
 	pIf->CheckConnection = CheckConnection;
 	pIf->GetRemoteHName = GetRemoteHName;
diff --git a/runtime/nsd_ossl.h b/runtime/nsd_ossl.h
index 33036b656c..a1e6d0b5d7 100644
--- a/runtime/nsd_ossl.h
+++ b/runtime/nsd_ossl.h
@@ -55,6 +55,11 @@ struct nsd_ossl_s {
 		OSSL_AUTH_CERTVALID = 2,
 		OSSL_AUTH_CERTANON = 3
 	} authMode;
+	enum {
+		OSSL_EXPIRED_PERMIT = 0,
+		OSSL_EXPIRED_DENY = 1,
+		OSSL_EXPIRED_WARN = 2
+	} permitExpiredCerts;
 	osslRtryCall_t rtryCall;/**< what must we retry? */
 	int rtryOsslErr;	/**< store ssl error code into like SSL_ERROR_WANT_READ or SSL_ERROR_WANT_WRITE */
 	int bIsInitiator;	/**< 0 if socket is the server end (listener), 1 if it is the initiator */
diff --git a/runtime/nsd_ptcp.c b/runtime/nsd_ptcp.c
index d6aa1b84c7..f4d3cffe67 100644
--- a/runtime/nsd_ptcp.c
+++ b/runtime/nsd_ptcp.c
@@ -175,6 +175,24 @@ SetAuthMode(nsd_t __attribute__((unused)) *pNsd, uchar *mode)
 }
 
 
+/* Set the PermitExpiredCerts mode. not supported in ptcp
+ * alorbach, 2018-12-20
+ */
+static rsRetVal
+SetPermitExpiredCerts(nsd_t __attribute__((unused)) *pNsd, uchar *mode)
+{
+	DEFiRet;
+	if(mode != NULL) {
+		LogError(0, RS_RET_VALUE_NOT_SUPPORTED, "error: permitexpiredcerts settingnot supported by "
+				"ptcp netstream driver");
+		ABORT_FINALIZE(RS_RET_VALUE_NOT_SUPPORTED);
+	}
+
+finalize_it:
+	RETiRet;
+}
+
+
 /* Set priorityString
  * PascalWithopf 2017-08-18 */
 static rsRetVal
@@ -594,6 +612,7 @@ LstnInit(netstrms_t *pNS, void *pUsr, rsRetVal(*fAddLstn)(void*,netstrm_t*),
 		CHKiRet(pNS->Drvr.SetSock(pNewNsd, sock));
 		CHKiRet(pNS->Drvr.SetMode(pNewNsd, netstrms.GetDrvrMode(pNS)));
 		CHKiRet(pNS->Drvr.SetAuthMode(pNewNsd, netstrms.GetDrvrAuthMode(pNS)));
+		CHKiRet(pNS->Drvr.SetPermitExpiredCerts(pNewNsd, netstrms.GetDrvrPermitExpiredCerts(pNS)));
 		CHKiRet(pNS->Drvr.SetPermPeers(pNewNsd, netstrms.GetDrvrPermPeers(pNS)));
 		CHKiRet(pNS->Drvr.SetGnutlsPriorityString(pNewNsd, netstrms.GetDrvrGnutlsPriorityString(pNS)));
 		CHKiRet(netstrms.CreateStrm(pNS, &pNewStrm));
@@ -927,6 +946,7 @@ CODESTARTobjQueryInterface(nsd_ptcp)
 	pIf->SetSock = SetSock;
 	pIf->SetMode = SetMode;
 	pIf->SetAuthMode = SetAuthMode;
+	pIf->SetPermitExpiredCerts = SetPermitExpiredCerts;
 	pIf->SetGnutlsPriorityString = SetGnutlsPriorityString;
 	pIf->SetPermPeers = SetPermPeers;
 	pIf->Rcv = Rcv;
diff --git a/runtime/tcpsrv.c b/runtime/tcpsrv.c
index f0b6f5b59a..58f6862daa 100644
--- a/runtime/tcpsrv.c
+++ b/runtime/tcpsrv.c
@@ -673,7 +673,7 @@ wrkr(void *const myself)
 	sigset_t sigSet;
 	sigfillset(&sigSet);
 	pthread_sigmask(SIG_SETMASK, &sigSet, NULL);
-	
+
 	pthread_mutex_lock(&wrkrMut);
 	while(1) {
 		// wait for work, in which case pSrv will be populated
@@ -1023,6 +1023,8 @@ tcpsrvConstructFinalize(tcpsrv_t *pThis)
 	CHKiRet(netstrms.SetDrvrMode(pThis->pNS, pThis->iDrvrMode));
 	if(pThis->pszDrvrAuthMode != NULL)
 		CHKiRet(netstrms.SetDrvrAuthMode(pThis->pNS, pThis->pszDrvrAuthMode));
+	if(pThis->pszDrvrPermitExpiredCerts != NULL)
+		CHKiRet(netstrms.SetDrvrPermitExpiredCerts(pThis->pNS, pThis->pszDrvrPermitExpiredCerts));
 	if(pThis->pPermPeers != NULL)
 		CHKiRet(netstrms.SetDrvrPermPeers(pThis->pNS, pThis->pPermPeers));
 	if(pThis->gnutlsPriorityString != NULL)
@@ -1057,6 +1059,7 @@ CODESTARTobjDestruct(tcpsrv)
 		netstrms.Destruct(&pThis->pNS);
 	free(pThis->pszDrvrName);
 	free(pThis->pszDrvrAuthMode);
+	free(pThis->pszDrvrPermitExpiredCerts);
 	free(pThis->ppLstn);
 	free(pThis->ppLstnPort);
 	free(pThis->pszInputName);
@@ -1391,6 +1394,18 @@ SetDrvrAuthMode(tcpsrv_t *pThis, uchar *mode)
 	RETiRet;
 }
 
+/* set the driver permitexpiredcerts mode -- alorbach, 2018-12-20
+ */
+static rsRetVal
+SetDrvrPermitExpiredCerts(tcpsrv_t *pThis, uchar *mode)
+{
+	DEFiRet;
+	ISOBJ_TYPE_assert(pThis, tcpsrv);
+	CHKmalloc(pThis->pszDrvrPermitExpiredCerts = ustrdup(mode));
+finalize_it:
+	RETiRet;
+}
+
 
 /* set the driver's permitted peers -- rgerhards, 2008-05-19 */
 static rsRetVal
@@ -1501,6 +1516,7 @@ CODESTARTobjQueryInterface(tcpsrv)
 	pIf->SetLstnMax = SetLstnMax;
 	pIf->SetDrvrMode = SetDrvrMode;
 	pIf->SetDrvrAuthMode = SetDrvrAuthMode;
+	pIf->SetDrvrPermitExpiredCerts = SetDrvrPermitExpiredCerts;
 	pIf->SetDrvrName = SetDrvrName;
 	pIf->SetDrvrPermPeers = SetDrvrPermPeers;
 	pIf->SetCBIsPermittedHost = SetCBIsPermittedHost;
diff --git a/runtime/tcpsrv.h b/runtime/tcpsrv.h
index 0763990921..55aa8e9922 100644
--- a/runtime/tcpsrv.h
+++ b/runtime/tcpsrv.h
@@ -64,6 +64,7 @@ struct tcpsrv_s {
 	uchar *gnutlsPriorityString;	/**< priority string for gnutls */
 	uchar *pszLstnPortFileName;	/**< File in which the dynamic port is written */
 	uchar *pszDrvrAuthMode;	/**< auth mode of the stream driver to use */
+	uchar *pszDrvrPermitExpiredCerts;/**< current driver setting for handlign expired certs */
 	uchar *pszDrvrName;	/**< name of stream driver to use */
 	uchar *pszInputName;	/**< value to be used as input name */
 	uchar *pszOrigin;		/**< module to be used as "origin" (e.g. for pstats) */
@@ -142,6 +143,7 @@ BEGINinterface(tcpsrv) /* name must also be changed in ENDinterface macro! */
 	rsRetVal (*SetCBOnErrClose)(tcpsrv_t*, rsRetVal (*) (tcps_sess_t*));
 	rsRetVal (*SetDrvrMode)(tcpsrv_t *pThis, int iMode);
 	rsRetVal (*SetDrvrAuthMode)(tcpsrv_t *pThis, uchar *pszMode);
+	rsRetVal (*SetDrvrPermitExpiredCerts)(tcpsrv_t *pThis, uchar *pszMode);
 	rsRetVal (*SetDrvrPermPeers)(tcpsrv_t *pThis, permittedPeers_t*);
 	/* session specifics */
 	rsRetVal (*SetCBOnSessAccept)(tcpsrv_t*, rsRetVal (*) (tcpsrv_t*, tcps_sess_t*));
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 564187a573..f220e1326a 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -903,11 +903,14 @@ endif
 if ENABLE_GNUTLS
 TESTS +=  \
 	imtcp_conndrop_tls.sh \
+	sndrcv_tls_anon_rebind.sh \
 	sndrcv_tls_anon_hostname.sh \
 	sndrcv_tls_anon_ipv4.sh \
+	sndrcv_tls_anon_ipv6.sh \
 	sndrcv_tls_priorityString.sh \
-	imtcp-tls-basic.sh \
-	sndrcv_tls_anon_rebind.sh
+	sndrcv_tls_certvalid.sh \
+	sndrcv_tls_certvalid_expired.sh \
+	imtcp-tls-basic.sh
 if HAVE_VALGRIND
 TESTS += \
 	imtcp-tls-basic-vg.sh \
@@ -922,6 +925,8 @@ TESTS +=  \
 	sndrcv_tls_ossl_anon_ipv4.sh \
 	sndrcv_tls_ossl_anon_ipv6.sh \
 	sndrcv_tls_ossl_anon_rebind.sh \
+	sndrcv_tls_ossl_certvalid.sh \
+	sndrcv_tls_ossl_certvalid_expired.sh \
 	imtcp-tls-ossl-x509valid.sh \
 	imtcp-tls-ossl-x509name.sh \
 	imtcp-tls-ossl-x509fingerprint.sh \
@@ -1190,6 +1195,8 @@ EXTRA_DIST= \
 	testsuites/x.509/client-key.pem \
 	testsuites/x.509/machine-cert.pem \
 	testsuites/x.509/machine-key.pem \
+	testsuites/x.509/client-expired-cert.pem \
+	testsuites/x.509/client-expired-key.pem \
 	cfg.sh \
 	cfg1.cfgtest \
 	cfg1.testin \
@@ -1506,6 +1513,8 @@ EXTRA_DIST= \
 	sndrcv_tls_ossl_anon_ipv4.sh \
 	sndrcv_tls_ossl_anon_ipv6.sh \
 	sndrcv_tls_ossl_anon_rebind.sh \
+	sndrcv_tls_ossl_certvalid.sh \
+	sndrcv_tls_ossl_certvalid_expired.sh \
 	imtcp-tls-ossl-x509valid.sh \
 	imtcp-tls-ossl-x509name.sh \
 	imtcp-tls-ossl-x509fingerprint.sh \
@@ -1945,6 +1954,8 @@ EXTRA_DIST= \
 	sndrcv_tls_anon_ipv4.sh \
 	sndrcv_tls_anon_ipv6.sh \
 	sndrcv_tls_priorityString.sh \
+	sndrcv_tls_certvalid.sh \
+	sndrcv_tls_certvalid_expired.sh \
 	omtcl.sh \
 	omtcl.tcl \
 	pmsnare-default.sh \
diff --git a/tests/sndrcv_tls_anon_ipv6.sh b/tests/sndrcv_tls_anon_ipv6.sh
index 31395e4e9b..a11ae6b81d 100755
--- a/tests/sndrcv_tls_anon_ipv6.sh
+++ b/tests/sndrcv_tls_anon_ipv6.sh
@@ -3,6 +3,7 @@
 # testing sending and receiving via TLS with anon auth using bare ipv6, no SNI
 # This file is part of the rsyslog project, released  under ASL 2.0
 . ${srcdir:=.}/diag.sh init
+. $srcdir/diag.sh check-ipv6-available
 export NUMMESSAGES=25000
 # uncomment for debugging support:
 #export RSYSLOG_DEBUG="debug nostdout noprintmutexaction"
diff --git a/tests/sndrcv_tls_certvalid.sh b/tests/sndrcv_tls_certvalid.sh
new file mode 100755
index 0000000000..b0c0f77140
--- /dev/null
+++ b/tests/sndrcv_tls_certvalid.sh
@@ -0,0 +1,72 @@
+#!/bin/bash
+# This file is part of the rsyslog project, released under ASL 2.0
+
+# uncomment for debugging support:
+. ${srcdir:=.}/diag.sh init
+# start up the instances
+#export RSYSLOG_DEBUG="debug nostdout noprintmutexaction"
+export RSYSLOG_DEBUGLOG="$RSYSLOG_DYNNAME.receiver.debuglog"
+generate_conf
+export PORT_RCVR="$(get_free_port)"
+add_conf '
+global(
+	defaultNetstreamDriverCAFile="'$srcdir/testsuites/x.509/ca.pem'"
+	defaultNetstreamDriverCertFile="'$srcdir/testsuites/x.509/client-cert.pem'"
+	defaultNetstreamDriverKeyFile="'$srcdir/testsuites/x.509/client-key.pem'"
+	defaultNetstreamDriver="gtls"
+#	debug.whitelist="on"
+#	debug.files=["nsd_ossl.c", "tcpsrv.c", "nsdsel_ossl.c", "nsdpoll_ptcp.c", "dnscache.c"]
+)
+
+module(	load="../plugins/imtcp/.libs/imtcp"
+	StreamDriver.Name="gtls"
+	StreamDriver.Mode="1"
+	StreamDriver.AuthMode="x509/certvalid" )
+input(	type="imtcp"
+	port="'$PORT_RCVR'" )
+
+template(name="outfmt" type="string" string="%msg:F,58:2%\n")
+:msg, contains, "msgnum:" action(	type="omfile" 
+					template="outfmt"
+					file="'$RSYSLOG_OUT_LOG'")
+'
+startup
+export RSYSLOG_DEBUGLOG="$RSYSLOG_DYNNAME.sender.debuglog"
+#valgrind="valgrind"
+generate_conf 2
+export TCPFLOOD_PORT="$(get_free_port)" # TODO: move to diag.sh
+add_conf '
+global(
+	defaultNetstreamDriverCAFile="'$srcdir/testsuites/x.509/ca.pem'"
+	defaultNetstreamDriverCertFile="'$srcdir/testsuites/x.509/client-cert.pem'"
+	defaultNetstreamDriverKeyFile="'$srcdir/testsuites/x.509/client-key.pem'"
+	defaultNetstreamDriver="gtls"
+)
+
+# Note: no TLS for the listener, this is for tcpflood!
+$ModLoad ../plugins/imtcp/.libs/imtcp
+$InputTCPServerRun '$TCPFLOOD_PORT'
+
+# set up the action
+$ActionSendStreamDriverMode 1 # require TLS for the connection
+$ActionSendStreamDriverAuthMode x509/certvalid
+*.*	@@127.0.0.1:'$PORT_RCVR'
+' 2
+startup 2
+
+# now inject the messages into instance 2. It will connect to instance 1,
+# and that instance will record the data.
+tcpflood -m10000 -i1
+sleep 5 # make sure all data is received in input buffers
+# shut down sender when everything is sent, receiver continues to run concurrently
+shutdown_when_empty 2
+wait_shutdown 2
+# now it is time to stop the receiver as well
+shutdown_when_empty
+wait_shutdown
+
+# do the final check
+seq_check 1 10000
+
+unset PORT_RCVR # TODO: move to exit_test()?
+exit_test
diff --git a/tests/sndrcv_tls_certvalid_expired.sh b/tests/sndrcv_tls_certvalid_expired.sh
new file mode 100755
index 0000000000..1e1facd638
--- /dev/null
+++ b/tests/sndrcv_tls_certvalid_expired.sh
@@ -0,0 +1,70 @@
+#!/bin/bash
+# This file is part of the rsyslog project, released under ASL 2.0
+
+# uncomment for debugging support:
+. ${srcdir:=.}/diag.sh init
+# start up the instances
+#export RSYSLOG_DEBUG="debug nostdout noprintmutexaction"
+export RSYSLOG_DEBUGLOG="$RSYSLOG_DYNNAME.receiver.debuglog"
+generate_conf
+export PORT_RCVR="$(get_free_port)"
+add_conf '
+global(
+	defaultNetstreamDriverCAFile="'$srcdir/testsuites/x.509/ca.pem'"
+	defaultNetstreamDriverCertFile="'$srcdir/testsuites/x.509/client-cert.pem'"
+	defaultNetstreamDriverKeyFile="'$srcdir/testsuites/x.509/client-key.pem'"
+	defaultNetstreamDriver="gtls"
+#	debug.whitelist="on"
+#	debug.files=["nsd_ossl.c", "tcpsrv.c", "nsdsel_ossl.c", "nsdpoll_ptcp.c", "dnscache.c"]
+)
+
+module(	load="../plugins/imtcp/.libs/imtcp"
+	StreamDriver.Name="gtls"
+	StreamDriver.Mode="1"
+	StreamDriver.AuthMode="x509/certvalid"
+	StreamDriver.PermitExpiredCerts="off"
+	)
+input(	type="imtcp"
+	port="'$PORT_RCVR'" )
+
+action(type="omfile" file="'$RSYSLOG_OUT_LOG'")
+'
+startup
+export RSYSLOG_DEBUGLOG="$RSYSLOG_DYNNAME.sender.debuglog"
+#valgrind="valgrind"
+generate_conf 2
+export TCPFLOOD_PORT="$(get_free_port)" # TODO: move to diag.sh
+add_conf '
+global(
+	defaultNetstreamDriverCAFile="'$srcdir/testsuites/x.509/ca.pem'"
+	defaultNetstreamDriverCertFile="'$srcdir/testsuites/x.509/client-expired-cert.pem'"
+	defaultNetstreamDriverKeyFile="'$srcdir/testsuites/x.509/client-expired-key.pem'"
+	defaultNetstreamDriver="gtls"
+)
+
+# Note: no TLS for the listener, this is for tcpflood!
+$ModLoad ../plugins/imtcp/.libs/imtcp
+$InputTCPServerRun '$TCPFLOOD_PORT'
+
+# set up the action
+$ActionSendStreamDriverMode 1 # require TLS for the connection
+$ActionSendStreamDriverAuthMode anon
+*.*	@@127.0.0.1:'$PORT_RCVR'
+' 2
+startup 2
+
+# now inject the messages into instance 2. It will connect to instance 1,
+# and that instance will record the data.
+tcpflood -m1 -i1
+sleep 5 # make sure all data is received in input buffers
+# shut down sender when everything is sent, receiver continues to run concurrently
+shutdown_when_empty 2
+wait_shutdown 2
+# now it is time to stop the receiver as well
+shutdown_when_empty
+wait_shutdown
+
+content_check "not permitted to talk to peer, certificate invalid: certificate expired"
+
+unset PORT_RCVR # TODO: move to exit_test()?
+exit_test
diff --git a/tests/sndrcv_tls_ossl_certvalid.sh b/tests/sndrcv_tls_ossl_certvalid.sh
new file mode 100755
index 0000000000..0604a4bb65
--- /dev/null
+++ b/tests/sndrcv_tls_ossl_certvalid.sh
@@ -0,0 +1,72 @@
+#!/bin/bash
+# This file is part of the rsyslog project, released under ASL 2.0
+
+# uncomment for debugging support:
+. ${srcdir:=.}/diag.sh init
+# start up the instances
+#export RSYSLOG_DEBUG="debug nostdout noprintmutexaction"
+export RSYSLOG_DEBUGLOG="$RSYSLOG_DYNNAME.receiver.debuglog"
+generate_conf
+export PORT_RCVR="$(get_free_port)"
+add_conf '
+global(
+	defaultNetstreamDriverCAFile="'$srcdir/testsuites/x.509/ca.pem'"
+	defaultNetstreamDriverCertFile="'$srcdir/testsuites/x.509/client-cert.pem'"
+	defaultNetstreamDriverKeyFile="'$srcdir/testsuites/x.509/client-key.pem'"
+	defaultNetstreamDriver="ossl"
+#	debug.whitelist="on"
+#	debug.files=["nsd_ossl.c", "tcpsrv.c", "nsdsel_ossl.c", "nsdpoll_ptcp.c", "dnscache.c"]
+)
+
+module(	load="../plugins/imtcp/.libs/imtcp"
+	StreamDriver.Name="ossl"
+	StreamDriver.Mode="1"
+	StreamDriver.AuthMode="x509/certvalid" )
+input(	type="imtcp"
+	port="'$PORT_RCVR'" )
+
+template(name="outfmt" type="string" string="%msg:F,58:2%\n")
+:msg, contains, "msgnum:" action(	type="omfile" 
+					template="outfmt"
+					file="'$RSYSLOG_OUT_LOG'")
+'
+startup
+export RSYSLOG_DEBUGLOG="$RSYSLOG_DYNNAME.sender.debuglog"
+#valgrind="valgrind"
+generate_conf 2
+export TCPFLOOD_PORT="$(get_free_port)" # TODO: move to diag.sh
+add_conf '
+global(
+	defaultNetstreamDriverCAFile="'$srcdir/testsuites/x.509/ca.pem'"
+	defaultNetstreamDriverCertFile="'$srcdir/testsuites/x.509/client-cert.pem'"
+	defaultNetstreamDriverKeyFile="'$srcdir/testsuites/x.509/client-key.pem'"
+	defaultNetstreamDriver="ossl"
+)
+
+# Note: no TLS for the listener, this is for tcpflood!
+$ModLoad ../plugins/imtcp/.libs/imtcp
+$InputTCPServerRun '$TCPFLOOD_PORT'
+
+# set up the action
+$ActionSendStreamDriverMode 1 # require TLS for the connection
+$ActionSendStreamDriverAuthMode x509/certvalid
+*.*	@@127.0.0.1:'$PORT_RCVR'
+' 2
+startup 2
+
+# now inject the messages into instance 2. It will connect to instance 1,
+# and that instance will record the data.
+tcpflood -m10000 -i1
+sleep 5 # make sure all data is received in input buffers
+# shut down sender when everything is sent, receiver continues to run concurrently
+shutdown_when_empty 2
+wait_shutdown 2
+# now it is time to stop the receiver as well
+shutdown_when_empty
+wait_shutdown
+
+# do the final check
+seq_check 1 10000
+
+unset PORT_RCVR # TODO: move to exit_test()?
+exit_test
diff --git a/tests/sndrcv_tls_ossl_certvalid_expired.sh b/tests/sndrcv_tls_ossl_certvalid_expired.sh
new file mode 100755
index 0000000000..c237f61e79
--- /dev/null
+++ b/tests/sndrcv_tls_ossl_certvalid_expired.sh
@@ -0,0 +1,71 @@
+#!/bin/bash
+# This file is part of the rsyslog project, released under ASL 2.0
+
+# uncomment for debugging support:
+. ${srcdir:=.}/diag.sh init
+# start up the instances
+#export RSYSLOG_DEBUG="debug nostdout noprintmutexaction"
+export RSYSLOG_DEBUGLOG="$RSYSLOG_DYNNAME.receiver.debuglog"
+generate_conf
+export PORT_RCVR="$(get_free_port)"
+add_conf '
+global(
+	defaultNetstreamDriverCAFile="'$srcdir/testsuites/x.509/ca.pem'"
+	defaultNetstreamDriverCertFile="'$srcdir/testsuites/x.509/client-cert.pem'"
+	defaultNetstreamDriverKeyFile="'$srcdir/testsuites/x.509/client-key.pem'"
+	defaultNetstreamDriver="ossl"
+#	debug.whitelist="on"
+#	debug.files=["nsd_ossl.c", "tcpsrv.c", "nsdsel_ossl.c", "nsdpoll_ptcp.c", "dnscache.c"]
+)
+
+module(	load="../plugins/imtcp/.libs/imtcp"
+	StreamDriver.Name="ossl"
+	StreamDriver.Mode="1"
+	StreamDriver.AuthMode="x509/certvalid"
+	StreamDriver.PermitExpiredCerts="off"
+	)
+input(	type="imtcp"
+	port="'$PORT_RCVR'" )
+
+action(type="omfile" file="'$RSYSLOG_OUT_LOG'")
+'
+startup
+export RSYSLOG_DEBUGLOG="$RSYSLOG_DYNNAME.sender.debuglog"
+#valgrind="valgrind"
+generate_conf 2
+export TCPFLOOD_PORT="$(get_free_port)" # TODO: move to diag.sh
+add_conf '
+global(
+	defaultNetstreamDriverCAFile="'$srcdir/testsuites/x.509/ca.pem'"
+	defaultNetstreamDriverCertFile="'$srcdir/testsuites/x.509/client-expired-cert.pem'"
+	defaultNetstreamDriverKeyFile="'$srcdir/testsuites/x.509/client-expired-key.pem'"
+	defaultNetstreamDriver="ossl"
+)
+
+# Note: no TLS for the listener, this is for tcpflood!
+$ModLoad ../plugins/imtcp/.libs/imtcp
+$InputTCPServerRun '$TCPFLOOD_PORT'
+
+# set up the action
+$ActionSendStreamDriverMode 1 # require TLS for the connection
+$ActionSendStreamDriverAuthMode anon
+*.*	@@127.0.0.1:'$PORT_RCVR'
+' 2
+startup 2
+
+# now inject the messages into instance 2. It will connect to instance 1,
+# and that instance will record the data.
+tcpflood -m1 -i1
+# sleep 5 # make sure all data is received in input buffers
+# shut down sender when everything is sent, receiver continues to run concurrently
+shutdown_when_empty 2
+wait_shutdown 2
+# now it is time to stop the receiver as well
+shutdown_when_empty
+wait_shutdown
+
+content_check "Certificate EXPIRED at depth"
+content_check "OpenSSL Error Stack:"
+
+unset PORT_RCVR # TODO: move to exit_test()?
+exit_test
diff --git a/tests/testsuites/x.509/client-expired-cert.pem b/tests/testsuites/x.509/client-expired-cert.pem
new file mode 100644
index 0000000000..d5fe9a22b4
--- /dev/null
+++ b/tests/testsuites/x.509/client-expired-cert.pem
@@ -0,0 +1,25 @@
+-----BEGIN CERTIFICATE-----
+MIIEPTCCAqWgAwIBAgIIXBEoYTa7GecwDQYJKoZIhvcNAQELBQAwRDERMA8GA1UE
+AxMIc29tZU5hbWUxEDAOBgNVBAsTB3JzeXNsb2cxEDAOBgNVBAoTB1NvbWVPcmcx
+CzAJBgNVBAYTAlVTMB4XDTE4MTIxMjE1MjUyMloXDTE4MTIxMzE1MjUyM1owdjEL
+MAkGA1UEAxMCVVMxEDAOBgNVBAsTB1NvbWVPcmgxDzANBgNVBAoTBlNvbWVPVTES
+MBAGA1UEBxMJU29tZXdoZXJlMQswCQYDVQQGEwJDQTEjMCEGCgmSJomT8ixkARkW
+E21hY2hpbmUuZXhhbXBsZS5uZXQwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEK
+AoIBAQC24qsJF2yax7Ja4xsPQ7lDtkEMx3ni6k0xh7VrzZiRFpegdz1CVerV8bAs
+voTzn1aTWE1lELRO7i4QTAU2sn/kyB34oNuQWd8R1D7J3FJsIE36RM15XmcQ4biX
+H6m9Kx5uEAfdHVSPLgwuQlQM6IshmxV5AS+QrqLK7scZCFpBEb379G4JeJJGdkXR
+p7VYXUo079YSA60TqhWH01dlJdvRmY6sBpYahAOag3f3d7L8eYd9Jv3S6pHxzf/5
+/TqMbYr7m4iPH+cXg/sDNMll66rax9Ei2dk/Za1GKQ1AUvlfto0qKaRg/2FUKhqP
+DGV5uJDbYxlZjD+2s8HSrlSPS70FAgMBAAGjgYAwfjAMBgNVHRMBAf8EAjAAMB0G
+A1UdJQQWMBQGCCsGAQUFBwMCBggrBgEFBQcDATAPBgNVHQ8BAf8EBQMDB6AAMB0G
+A1UdDgQWBBTKFNJvJb22tIrAxnqkVRDvFqukcTAfBgNVHSMEGDAWgBSwn2czLIiI
+iR9EYnSdJf/ABhNd1jANBgkqhkiG9w0BAQsFAAOCAYEAXV+3oTx+/LEL8yHUbRS2
+wQ+kuXuuGJT4nkOFD+m5vNWtM1jGoj1trV/MxC697JlKB4wmBebKvIXcdKTVy2CB
+MqPoKTHSJ4vqfAWYAP9i0nNrxcvi0mHVxlRqPnizPLUkcPCYvnPtnSOCELmWk0mC
+i9K2QUy9e9HulRayaVU8KdPwopy6aJJQyl981T/h/m+q0FcKOIC27nn0VW0ZGHtl
+1PnUTVOP479HNhMg6zmPKxV0Y/WVQDB0Cpok3uuo0V1I9BuQk7Rn6DQqSnNI7/vH
+Ot/5fPEk/SU4OitCH7yV8XnkrPfAhpPrsUrVUd54PQg/KZu9qVTfMAM+j55aDCs7
+HlfrkSB+Jv4YOdlgrSMnstG45WIAYGD32sCPog5F9mJl6BFREcgscQ1BF7Tr/LX2
+d8PaePwRfdHuRDsY4Ydq+F89cP23QNIlxf9r8ODe13v1mfCXpzxksZ8zhxEzPm46
+efGuPdwdb+u6ZRiOqoaAavV9raKCEX5CrvqKeDnZ66WA
+-----END CERTIFICATE-----
diff --git a/tests/testsuites/x.509/client-expired-key.pem b/tests/testsuites/x.509/client-expired-key.pem
new file mode 100644
index 0000000000..b53d6f3296
--- /dev/null
+++ b/tests/testsuites/x.509/client-expired-key.pem
@@ -0,0 +1,134 @@
+Public Key Info:
+	Public Key Algorithm: RSA
+	Key Security Level: Medium (2048 bits)
+
+modulus:
+	00:b6:e2:ab:09:17:6c:9a:c7:b2:5a:e3:1b:0f:43:b9
+	43:b6:41:0c:c7:79:e2:ea:4d:31:87:b5:6b:cd:98:91
+	16:97:a0:77:3d:42:55:ea:d5:f1:b0:2c:be:84:f3:9f
+	56:93:58:4d:65:10:b4:4e:ee:2e:10:4c:05:36:b2:7f
+	e4:c8:1d:f8:a0:db:90:59:df:11:d4:3e:c9:dc:52:6c
+	20:4d:fa:44:cd:79:5e:67:10:e1:b8:97:1f:a9:bd:2b
+	1e:6e:10:07:dd:1d:54:8f:2e:0c:2e:42:54:0c:e8:8b
+	21:9b:15:79:01:2f:90:ae:a2:ca:ee:c7:19:08:5a:41
+	11:bd:fb:f4:6e:09:78:92:46:76:45:d1:a7:b5:58:5d
+	4a:34:ef:d6:12:03:ad:13:aa:15:87:d3:57:65:25:db
+	d1:99:8e:ac:06:96:1a:84:03:9a:83:77:f7:77:b2:fc
+	79:87:7d:26:fd:d2:ea:91:f1:cd:ff:f9:fd:3a:8c:6d
+	8a:fb:9b:88:8f:1f:e7:17:83:fb:03:34:c9:65:eb:aa
+	da:c7:d1:22:d9:d9:3f:65:ad:46:29:0d:40:52:f9:5f
+	b6:8d:2a:29:a4:60:ff:61:54:2a:1a:8f:0c:65:79:b8
+	90:db:63:19:59:8c:3f:b6:b3:c1:d2:ae:54:8f:4b:bd
+	05:
+
+public exponent:
+	01:00:01:
+
+private exponent:
+	43:a8:45:67:fe:9f:71:ff:50:af:28:f7:58:c5:50:23
+	89:a8:35:07:12:c3:6c:b4:94:0f:45:81:95:34:cc:f0
+	13:b6:0c:86:c0:24:b2:d4:e5:2d:ac:cf:ea:b5:8a:0b
+	e8:44:b1:95:23:01:e1:75:61:db:2b:94:7e:30:b8:f9
+	b5:42:c9:39:11:21:2c:ee:46:55:43:c9:3f:d5:ca:24
+	85:54:81:e1:95:f5:e3:a1:2e:30:30:d0:48:e6:2f:ae
+	79:3f:3a:f9:85:21:44:3a:df:cc:b9:43:08:e7:7a:99
+	3b:1b:4d:81:af:cc:11:9f:2d:fd:f9:ef:fb:d4:0f:df
+	d4:fe:65:70:c9:d2:3c:08:7b:ad:d5:34:af:c6:13:cf
+	15:b5:82:31:02:52:d2:73:a9:e5:d1:5f:67:c1:a5:72
+	e1:e4:4f:14:c6:fb:70:db:b8:43:ba:25:ea:4a:57:d6
+	30:ec:e4:c0:8c:24:c5:83:d7:68:9b:96:e1:7c:57:1f
+	4c:2f:e3:76:9b:bb:b8:e6:86:52:87:fe:d2:a3:b3:bd
+	30:c0:0e:f6:d2:fe:6d:e9:5b:24:5c:f4:b8:ba:da:d4
+	47:eb:d5:30:da:3b:1d:03:1f:ad:49:a2:05:34:f0:a1
+	a8:a2:08:e2:ed:ba:03:1c:60:4a:ea:fa:08:4c:88:5d
+	
+
+prime1:
+	00:ca:bc:76:2f:11:58:28:51:bf:a2:a0:23:43:b3:25
+	1a:56:2c:2e:56:05:24:a7:4b:e0:75:d3:ba:e7:31:20
+	2b:a2:fc:91:13:6b:b6:5b:c6:21:71:2d:6d:aa:d7:1f
+	b8:d9:86:ea:00:49:19:e7:d0:c1:2e:43:50:83:fd:b9
+	a3:1d:51:c7:ee:45:0b:a9:c0:26:70:da:a6:3b:ea:d8
+	2f:dc:98:ce:f7:95:84:24:a3:d8:54:57:90:64:63:f3
+	f7:9f:75:02:d8:c7:4e:9f:7d:60:f3:dc:b1:83:bc:42
+	08:ae:5f:ac:94:b1:74:bf:57:fc:96:0a:44:14:7b:f5
+	d3:
+
+prime2:
+	00:e6:ef:17:e0:2d:ef:36:07:c3:c2:42:44:d0:fb:e6
+	d6:f5:7d:c4:5d:54:17:e0:ec:1d:6c:84:52:cf:90:a4
+	aa:a5:d0:7c:c6:e6:f0:56:aa:73:27:5c:c1:91:4d:d5
+	60:7d:9c:a3:96:1a:cb:b1:e7:8e:cb:53:52:2e:35:53
+	74:46:e9:ff:67:fb:93:5b:94:78:b0:0f:b9:a7:2f:08
+	fe:84:d3:f5:3e:f0:b7:02:a8:41:4e:9c:65:d7:f8:95
+	7e:82:ef:5f:3c:60:12:2e:6f:3f:a8:df:b3:bf:3b:ed
+	ac:07:ef:0f:d7:35:c7:81:30:a2:18:05:14:72:6c:02
+	c7:
+
+coefficient:
+	60:35:5f:cb:5b:40:75:b3:57:b8:61:d8:5a:40:c1:91
+	01:3a:c1:17:35:94:4b:81:06:e9:75:56:8c:97:e3:bb
+	5a:7d:f5:f1:ac:f8:6f:d0:a2:6c:89:a4:8a:0d:23:78
+	8a:92:b6:3f:7c:42:00:65:c8:d7:b4:77:19:fd:2f:75
+	e8:99:c4:60:c5:48:f5:74:4d:09:63:a2:b5:cd:01:0e
+	70:8d:69:03:f0:58:e6:7c:47:93:40:f3:53:9f:d5:97
+	3a:13:2e:10:aa:17:77:74:67:82:2a:20:5b:fa:96:51
+	cf:58:c8:a4:c4:58:f4:5a:88:42:49:4a:ad:5c:6e:00
+	
+
+exp1:
+	57:8a:b7:91:ad:70:9e:c0:65:fa:88:21:92:1b:2a:1b
+	4c:38:79:ad:a5:3c:e5:8c:8b:18:f5:db:4f:f7:53:87
+	e4:32:21:46:fc:8c:da:e6:1c:0c:ad:ec:1c:08:16:67
+	90:6e:84:5e:a9:32:29:7a:67:e0:5d:2a:c8:43:e8:43
+	f9:e6:15:69:da:a0:a5:a5:16:34:47:05:de:fb:92:6c
+	60:5a:0f:8c:b3:20:43:5e:08:8c:aa:de:eb:aa:89:6f
+	54:88:87:39:2a:1e:d6:19:a2:a2:ca:9a:50:63:1b:34
+	7a:6f:4f:ab:49:51:3b:4a:78:04:25:dc:ad:e7:b5:07
+	
+
+exp2:
+	19:ee:59:10:fc:37:73:2a:b6:09:97:25:61:0e:18:22
+	a5:18:45:37:71:9c:e8:cd:ba:94:17:db:b0:a0:fe:4c
+	87:27:fd:0a:dc:9d:ba:2d:93:96:a4:ec:bb:63:31:05
+	8f:b5:4a:0d:2d:df:17:8f:f7:d1:ce:fe:58:5f:f6:8a
+	04:f8:7b:8c:72:8c:5e:69:32:90:1a:83:ef:48:f1:ca
+	9a:a1:ae:55:2d:f4:6e:e0:f3:cc:5e:f5:74:a5:de:2b
+	81:8a:5d:78:4b:15:5f:8f:70:67:87:0f:08:f7:32:bd
+	f1:7a:1f:9e:3b:d4:b6:25:fe:dd:91:9c:75:28:b9:bb
+	
+
+
+Public Key PIN:
+	pin-sha256:ixzIAak4pRfFjtaG95FtWd+Iu8vB5m6nknYP5EGaAqg=
+Public Key ID:
+	sha256:8b1cc801a938a517c58ed686f7916d59df88bbcbc1e66ea792760fe4419a02a8
+	sha1:ca14d26f25bdb6b48ac0c67aa45510ef16aba471
+
+-----BEGIN RSA PRIVATE KEY-----
+MIIEogIBAAKCAQEAtuKrCRdsmseyWuMbD0O5Q7ZBDMd54upNMYe1a82YkRaXoHc9
+QlXq1fGwLL6E859Wk1hNZRC0Tu4uEEwFNrJ/5Mgd+KDbkFnfEdQ+ydxSbCBN+kTN
+eV5nEOG4lx+pvSsebhAH3R1Ujy4MLkJUDOiLIZsVeQEvkK6iyu7HGQhaQRG9+/Ru
+CXiSRnZF0ae1WF1KNO/WEgOtE6oVh9NXZSXb0ZmOrAaWGoQDmoN393ey/HmHfSb9
+0uqR8c3/+f06jG2K+5uIjx/nF4P7AzTJZeuq2sfRItnZP2WtRikNQFL5X7aNKimk
+YP9hVCoajwxlebiQ22MZWYw/trPB0q5Uj0u9BQIDAQABAoIBAEOoRWf+n3H/UK8o
+91jFUCOJqDUHEsNstJQPRYGVNMzwE7YMhsAkstTlLazP6rWKC+hEsZUjAeF1Ydsr
+lH4wuPm1Qsk5ESEs7kZVQ8k/1cokhVSB4ZX146EuMDDQSOYvrnk/OvmFIUQ638y5
+Qwjnepk7G02Br8wRny39+e/71A/f1P5lcMnSPAh7rdU0r8YTzxW1gjECUtJzqeXR
+X2fBpXLh5E8Uxvtw27hDuiXqSlfWMOzkwIwkxYPXaJuW4XxXH0wv43abu7jmhlKH
+/tKjs70wwA720v5t6VskXPS4utrUR+vVMNo7HQMfrUmiBTTwoaiiCOLtugMcYErq
++ghMiF0CgYEAyrx2LxFYKFG/oqAjQ7MlGlYsLlYFJKdL4HXTuucxICui/JETa7Zb
+xiFxLW2q1x+42YbqAEkZ59DBLkNQg/25ox1Rx+5FC6nAJnDapjvq2C/cmM73lYQk
+o9hUV5BkY/P3n3UC2MdOn31g89yxg7xCCK5frJSxdL9X/JYKRBR79dMCgYEA5u8X
+4C3vNgfDwkJE0Pvm1vV9xF1UF+DsHWyEUs+QpKql0HzG5vBWqnMnXMGRTdVgfZyj
+lhrLseeOy1NSLjVTdEbp/2f7k1uUeLAPuacvCP6E0/U+8LcCqEFOnGXX+JV+gu9f
+PGASLm8/qN+zvzvtrAfvD9c1x4EwohgFFHJsAscCgYBXireRrXCewGX6iCGSGyob
+TDh5raU85YyLGPXbT/dTh+QyIUb8jNrmHAyt7BwIFmeQboReqTIpemfgXSrIQ+hD
++eYVadqgpaUWNEcF3vuSbGBaD4yzIENeCIyq3uuqiW9UiIc5Kh7WGaKiyppQYxs0
+em9Pq0lRO0p4BCXcree1BwKBgBnuWRD8N3MqtgmXJWEOGCKlGEU3cZzozbqUF9uw
+oP5Mhyf9Ctydui2TlqTsu2MxBY+1Sg0t3xeP99HO/lhf9ooE+HuMcoxeaTKQGoPv
+SPHKmqGuVS30buDzzF71dKXeK4GKXXhLFV+PcGeHDwj3Mr3xeh+eO9S2Jf7dkZx1
+KLm7AoGAYDVfy1tAdbNXuGHYWkDBkQE6wRc1lEuBBul1VoyX47taffXxrPhv0KJs
+iaSKDSN4ipK2P3xCAGXI17R3Gf0vdeiZxGDFSPV0TQljorXNAQ5wjWkD8FjmfEeT
+QPNTn9WXOhMuEKoXd3RngiogW/qWUc9YyKTEWPRaiEJJSq1cbgA=
+-----END RSA PRIVATE KEY-----
diff --git a/tests/testsuites/x.509/expired-ca-key.pem b/tests/testsuites/x.509/expired-ca-key.pem
deleted file mode 100644
index 1e1a0b26b3..0000000000
--- a/tests/testsuites/x.509/expired-ca-key.pem
+++ /dev/null
@@ -1,15 +0,0 @@
------BEGIN RSA PRIVATE KEY-----
-MIICXQIBAAKBgQDZnIJGJH80j2DPBXdxgmFmBRMoBnpwQb8yhRJcJacaWigRAhp4
-wdo07rR+EpuBJHD/5ImIygUwCj/XWAs4JKm3LqK2ih1gUy/s6Tg2O5t3k11kdjEH
-MKUxDOLs441dEwERPQtePEoy2POzViIyy959ZJorkdnwC4LBKdQVLEELlwIDAQAB
-AoGAEQWvoRoAw1VF3tvQHJZ01Pyno3ViRX63HJYROhkN6b9MrAvsky6iyYo0nzoI
-ZQE7P6EaaxNWdYwPs2IlOoaPqeos1sGVDaK/JFuja/DduoXBdCy9RFWRaugDX/1U
-iMtjtu29euvegP0r2RIxaIl9dapF5alNH5MLMyBl7XTB+/kCQQDiwHnW8jS1paSc
-/risF6Ie5rKuUfVDG8hqMEiKyczSHwUVYushwCclshjM6E1TBFZqMz/8PbFW51pK
-OzFS2s6/AkEA9a4044RL3AWe37LIU4hbz2Y+auRvPh8x4i2cWLzdok8Rc1EHDGLN
-eHBoOQ3Q2nQS94cOx6HxpRztzBgiwpTRKQJADX9BgV7nbkyO0N2EppG9j7NRvXiZ
-bcYwlsmK99/tNjCsf8pkjpy+d8rzGPdW6vMeJbIpQ910OeUJhdOiKvllRwJBAIw3
-rP/dVd5xZseNpj/mp1+rnxwq3EK8UyAfoAgVYvlr3y3NpRQwn8yJezJ07CqB7QFR
-F+JgTyZJaH7/l3cusGECQQCM3HmkADAKxX6RwKe8X0Kj/36rjXEMNoq0ZdXOB7Qz
-f5N6og4Da9y/ZO+XMo6P3XR/TYIYrMD8nuoR33X69kb1
------END RSA PRIVATE KEY-----
diff --git a/tests/testsuites/x.509/expired-ca.pem b/tests/testsuites/x.509/expired-ca.pem
deleted file mode 100644
index a733eb862e..0000000000
--- a/tests/testsuites/x.509/expired-ca.pem
+++ /dev/null
@@ -1,17 +0,0 @@
------BEGIN CERTIFICATE-----
-MIICyzCCAjagAwIBAgIESFo2XjALBgkqhkiG9w0BAQUwezELMAkGA1UEBhMCVVMx
-EDAOBgNVBAoTB1NvbWVPcmcxDzANBgNVBAsTBlNvbWVPVTESMBAGA1UEBxMJU29t
-ZXdoZXJlMQswCQYDVQQIEwJDQTEoMCYGA1UEAxMfc29tZU5hbWUgKG5vdCBuZWNl
-c3NhcmlseSBETlMhKTAeFw0wODA2MTkxMDM1MTJaFw0xODA2MTcxMDM1MjVaMHsx
-CzAJBgNVBAYTAlVTMRAwDgYDVQQKEwdTb21lT3JnMQ8wDQYDVQQLEwZTb21lT1Ux
-EjAQBgNVBAcTCVNvbWV3aGVyZTELMAkGA1UECBMCQ0ExKDAmBgNVBAMTH3NvbWVO
-YW1lIChub3QgbmVjZXNzYXJpbHkgRE5TISkwgZwwCwYJKoZIhvcNAQEBA4GMADCB
-iAKBgNmcgkYkfzSPYM8Fd3GCYWYFEygGenBBvzKFElwlpxpaKBECGnjB2jTutH4S
-m4EkcP/kiYjKBTAKP9dYCzgkqbcuoraKHWBTL+zpODY7m3eTXWR2MQcwpTEM4uzj
-jV0TARE9C148SjLY87NWIjLL3n1kmiuR2fALgsEp1BUsQQuXAgMBAAGjYzBhMA8G
-A1UdEwEB/wQFMAMBAf8wHgYDVR0RBBcwFYETc29tZW9uZUBleGFtcGxlLm5ldDAP
-BgNVHQ8BAf8EBQMDBwQAMB0GA1UdDgQWBBT7/paNEKc65bcNe0NIhsj4cpl7iTAL
-BgkqhkiG9w0BAQUDgYEAlv9ge8Koways837OLoZIam0s7wQCcwd9rWE05caps7BU
-T4bfgab9U/e9mmrf3V/zXmtU6y8hhTXF5AcZv3/EmCVwsPRotgrJ+rHXTv5e2PO7
-/8C3K2Lhc89gF4qf4xZwlZU70RasKgCzZa5ivS2Y8pW6LUu6eqqgVw3pPJbW3TE=
------END CERTIFICATE-----
diff --git a/tests/testsuites/x.509/expired-client-cert.pem b/tests/testsuites/x.509/expired-client-cert.pem
deleted file mode 100644
index 5bf39f818c..0000000000
--- a/tests/testsuites/x.509/expired-client-cert.pem
+++ /dev/null
@@ -1,16 +0,0 @@
------BEGIN CERTIFICATE-----
-MIICijCCAfWgAwIBAgIESFo7ITALBgkqhkiG9w0BAQUwezELMAkGA1UEBhMCVVMx
-EDAOBgNVBAoTB1NvbWVPcmcxDzANBgNVBAsTBlNvbWVPVTESMBAGA1UEBxMJU29t
-ZXdoZXJlMQswCQYDVQQIEwJDQTEoMCYGA1UEAxMfc29tZU5hbWUgKG5vdCBuZWNl
-c3NhcmlseSBETlMhKTAeFw0wODA2MTkxMDU1MzJaFw0xMTAzMTYxMDU1MzlaMA0x
-CzAJBgNVBAYTAlVTMIGcMAsGCSqGSIb3DQEBAQOBjAAwgYgCgYC+f6yCet2WJgmw
-tgukOReI+avRHOfr2hLhIQkSzCOiNi0tNWMKmaQWw/D+y1FvLRq0wLDUyJK/36rB
-67HKfscoNeClKTS8jhAs1mPjT57iyuoqK6VW/d2JoofklRCgDIZQrNfxHiOO+kN3
-ShLmkGqxkA3YyUty/JmF6PKWYIhQWQIDAQABo4GPMIGMMAwGA1UdEwEB/wQCMAAw
-HQYDVR0lBBYwFAYIKwYBBQUHAwIGCCsGAQUFBwMBMB0GA1UdEQQWMBSCEmNsaWVu
-dC5leGFtcGxlLm5ldDAdBgNVHQ4EFgQUrDcwsuOF4RiHn0eboCplJSiUhfcwHwYD
-VR0jBBgwFoAU+/6WjRCnOuW3DXtDSIbI+HKZe4kwCwYJKoZIhvcNAQEFA4GBAAAh
-niy9ORW2AIb6lk/sa3iYczeYpGzxDM9bLZ1xSoIdoHM/v9gPG/WpAZ4ECHjx+Yk8
-4B/9gvaAmMi0FmcoIBQaEOe2P8tcIuzmum3N2F27F2+J4httiNDLJoseWVnXJUvS
-dPyVOrKXdl5vVFpmViI5P+VzzMqbAQ6oNlMXIh6e
------END CERTIFICATE-----
diff --git a/tests/testsuites/x.509/expired-client-key.pem b/tests/testsuites/x.509/expired-client-key.pem
deleted file mode 100644
index 056412130e..0000000000
--- a/tests/testsuites/x.509/expired-client-key.pem
+++ /dev/null
@@ -1,15 +0,0 @@
------BEGIN RSA PRIVATE KEY-----
-MIICWwIBAAKBgQC+f6yCet2WJgmwtgukOReI+avRHOfr2hLhIQkSzCOiNi0tNWMK
-maQWw/D+y1FvLRq0wLDUyJK/36rB67HKfscoNeClKTS8jhAs1mPjT57iyuoqK6VW
-/d2JoofklRCgDIZQrNfxHiOO+kN3ShLmkGqxkA3YyUty/JmF6PKWYIhQWQIDAQAB
-AoGAVxrM+BqTIJlC/Ay5lP1QAB9di3ACserUkCFJY1F5h63rCU1sfIfVKl2s3+x6
-z3GZ0QV8tccCpv5wN1x8vqEqkbOvddM3rzpGkEC5PoyfCzuQBun1wnHK/JKjrfk5
-PvcaP60eTNjHZC7w78gOJJCzgzsEMrndtE+55diPmqGVtXMCQQDTZBy5WK8gZwMO
-rRz1BKKyBeMYMfTJoJafGfxp0H8AUbTa0V2eb+el3kuzPCm3FQ6IgaHyGj2WqkAw
-M0bfAfdXAkEA5rLna1t+2SCtgSd1DotndA4EsH4skBq9kFeD2/8T6Pf13zmBOq6O
-4aNEOhgBE/R9/MI4XoU9MbOlkZvKvDuXzwJADdWSb6rXIza6o34+0+Yuw5nRB+dV
-DtD8qoLn2wDzHtE6Fcv35YOLVHac26kHTd0J63MYZyDCgRa5Rq5EaBnX1wJAQYRF
-XKPbXmZ9X9SI1dyZQMhKZKUwmqw9caSo+e1zBhKFbSOzo6q3QTVQxv7SL4ybyxCN
-WaqVOmw+dR+9b7+s2QJAdNAw3r418rWKFKJJNTSqSqr1sYqiKvrQL6w2dpdpAeY4
-3VDCz/7/F9AEn3R7K3fZLQ7W6M62LSEjxxc1Y3LIpQ==
------END RSA PRIVATE KEY-----
diff --git a/tests/testsuites/x.509/expired-machine-cert.pem b/tests/testsuites/x.509/expired-machine-cert.pem
deleted file mode 100644
index fa2fd36e9c..0000000000
--- a/tests/testsuites/x.509/expired-machine-cert.pem
+++ /dev/null
@@ -1,18 +0,0 @@
------BEGIN CERTIFICATE-----
-MIIC7TCCAligAwIBAgIESFo4GTALBgkqhkiG9w0BAQUwezELMAkGA1UEBhMCVVMx
-EDAOBgNVBAoTB1NvbWVPcmcxDzANBgNVBAsTBlNvbWVPVTESMBAGA1UEBxMJU29t
-ZXdoZXJlMQswCQYDVQQIEwJDQTEoMCYGA1UEAxMfc29tZU5hbWUgKG5vdCBuZWNl
-c3NhcmlseSBETlMhKTAeFw0wODA2MTkxMDQyNTRaFw0xMTAzMTYxMDQyNTdaMG8x
-CzAJBgNVBAYTAlVTMRAwDgYDVQQKEwdTb21lT3JnMQ8wDQYDVQQLEwZTb21lT1Ux
-EjAQBgNVBAcTCVNvbWV3aGVyZTELMAkGA1UECBMCQ0ExHDAaBgNVBAMTE21hY2hp
-bmUuZXhhbXBsZS5uZXQwgZwwCwYJKoZIhvcNAQEBA4GMADCBiAKBgLJOW6lIHv8u
-c6Ez7tiir64vI3aRuDmUACPybyWtyWqrLebzYtg+borWHj9y5di54NB5wpQhZQsQ
-U2awNqanzUYeLGqbecbuxuLtsKlZ4knax+PwHOBTmIcN1SjbpII27Toe0VwHE5Vd
-sygFFyorto6OeNLPrIcTFfwXQ2sVw325AgMBAAGjgZAwgY0wDAYDVR0TAQH/BAIw
-ADAdBgNVHSUEFjAUBggrBgEFBQcDAgYIKwYBBQUHAwEwHgYDVR0RBBcwFYITbWFj
-aGluZS5leGFtcGxlLm5ldDAdBgNVHQ4EFgQUDOHD29GdMfoDWwev4uDvItkLKKww
-HwYDVR0jBBgwFoAU+/6WjRCnOuW3DXtDSIbI+HKZe4kwCwYJKoZIhvcNAQEFA4GB
-AMt1iED7QzFL2Qk6VivoFY15S2XGF8rJTd3l00bwyLA5qLyLBGlB6z4qkYu7/7SW
-5r7tet+1DezgHrj/1eU289m410wnQB8fGwcVLp6OX2PAlhNmVLcsipiN6rielAcP
-aIg/VlBtoCFp/ymTLKgvh6DLKWhRUkFPqO2WtcQ3UUo+
------END CERTIFICATE-----
diff --git a/tests/testsuites/x.509/expired-machine-key.pem b/tests/testsuites/x.509/expired-machine-key.pem
deleted file mode 100644
index 808f00c98b..0000000000
--- a/tests/testsuites/x.509/expired-machine-key.pem
+++ /dev/null
@@ -1,15 +0,0 @@
------BEGIN RSA PRIVATE KEY-----
-MIICXAIBAAKBgQCyTlupSB7/LnOhM+7Yoq+uLyN2kbg5lAAj8m8lrclqqy3m82LY
-Pm6K1h4/cuXYueDQecKUIWULEFNmsDamp81GHixqm3nG7sbi7bCpWeJJ2sfj8Bzg
-U5iHDdUo26SCNu06HtFcBxOVXbMoBRcqK7aOjnjSz6yHExX8F0NrFcN9uQIDAQAB
-AoGABHJs2c95Km8bpikX62I/VG5LiaD/wbvdtwfMWtm3PMhRKEHotLD169OERJvW
-fK3CHCD1R+F/ViPNmLGLY2Oq/GqKjhKjg4sqAznw8TImBSgXCFho4sl38z+luP1o
-TXFDgfV5HDDW1/F5kJlBIfXBLFdl4VO7E0ZnFt4FqSDRW2MCQQDRun/sBGM4i9hM
-QdC+QwrdcgCScBpzbz4YXtI9TyGEqNahg8kXgIVUbzDdRmG68G2M98USzRs5DWB7
-YvYwmRoPAkEA2aUdUpFRb/n7XfsAiFLYOk96C82iCCQpJi0si34zlCAEbCRbQ6zw
-gVDMCMSccnnWrVzqtxfN+rXycFTNyDFTtwJAPRwymfrNTnSxGcczo7y1NcE6GXFA
-w9HuLfuzFtov0g/AOl/EAG0abHfZrSAM6gOUaDbp3YiWHhGfw1QamB6EUQJAClTb
-MnsxeXZNZ2Wt3crI9uOk8IB/a5GD3osQbUK9Yg+vBg8nweuoswrJ1LS4lHqSJUKe
-5bgckAUpEAoGhrVIuwJBAKIuqx/cSjF4Oa9xT6DzBRe7vAlKFq62lUV5SLfoSEgY
-L5dvPBgAD0Styglny1s0Bu5FTlkxlFOMvUAD/O5hsQw=
------END RSA PRIVATE KEY-----
diff --git a/tests/testsuites/x.509/request.pem b/tests/testsuites/x.509/request.pem
deleted file mode 100644
index 2656c7d8ef..0000000000
--- a/tests/testsuites/x.509/request.pem
+++ /dev/null
@@ -1,77 +0,0 @@
-PKCS #10 Certificate Request Information:
-	Version: 1
-	Subject: C=US,ST=CA,O=SomeOrg,OU=SomeUnit,CN=rsyslog client
-	Subject Public Key Algorithm: RSA
-	Algorithm Security Level: High (3072 bits)
-		Modulus (bits 3072):
-			00:9d:91:da:d8:2e:3d:9d:ae:85:c3:c5:a7:f6:a4:66
-			f8:c8:91:91:b8:70:20:dc:ed:e8:23:ca:53:f7:b8:52
-			43:f3:a7:eb:fb:df:8a:3b:2c:b0:13:fa:62:d3:a1:53
-			a4:51:71:1f:68:d9:fd:bc:39:4a:fb:c9:6a:df:f3:88
-			84:b0:80:bc:c0:f5:1b:42:11:f6:4c:1a:d8:2c:62:0b
-			5d:50:64:30:9a:d3:db:c1:d5:7f:39:53:e4:bd:e8:1e
-			04:9d:c9:12:e0:e4:57:29:29:01:b9:f1:e5:bc:74:a6
-			e7:4b:61:e6:67:5c:6c:4e:ee:ee:22:0c:1b:14:6d:e8
-			0c:6f:ee:ee:c3:b8:dd:df:15:ed:7a:96:5b:cc:85:e5
-			e3:50:c4:ce:2b:bf:b6:37:e6:20:fc:6e:45:7e:09:bd
-			84:7a:af:07:27:f4:99:23:41:df:36:d8:29:31:a0:96
-			84:2f:fd:45:2e:d4:b4:f9:fa:dc:8f:23:c0:e0:06:ad
-			ad:0a:72:da:f4:3b:a1:cb:d6:a6:3b:ec:46:c4:95:f2
-			71:a5:ad:08:1f:e7:06:18:0e:db:80:51:96:ba:24:f6
-			64:02:6b:d3:f0:76:01:34:3a:72:02:e9:cb:d0:aa:62
-			51:0c:8f:83:be:c0:47:99:d2:92:72:ed:53:a5:49:05
-			d4:c9:a1:f4:4d:de:12:9d:1a:c8:17:84:f3:a2:7c:67
-			47:82:4b:86:1e:73:86:e2:26:26:10:94:a3:99:9b:08
-			99:78:9d:3d:33:5d:85:c2:46:65:94:ab:70:b4:3b:c1
-			26:8b:11:b6:66:27:88:22:84:03:b5:08:45:32:8c:81
-			23:be:62:dc:6f:a0:aa:5e:9f:03:f7:a7:f5:03:70:3c
-			78:09:d0:84:44:8c:19:af:76:f7:93:fc:af:c6:fd:db
-			d9:4c:cb:20:79:44:71:cb:e6:55:61:a9:7a:af:0b:a3
-			a6:ed:e9:a9:11:af:fa:a3:5d:ac:97:e7:ef:2b:b6:a8
-			37
-		Exponent (bits 24):
-			01:00:01
-	Signature Algorithm: RSA-SHA256
-	Attributes:
-		Extensions:
-			Basic Constraints (critical):
-				Certificate Authority (CA): FALSE
-			Key Usage (critical):
-				Digital signature.
-				Key encipherment.
-			Key Purpose (critical):
-				TLS WWW Client.
-				TLS WWW Server.
-Other Information:
-	Public Key ID:
-		sha1:9417ae9d2157b87bc1ae107b08a921bca114008b
-		sha256:68a391a6bd3c60ad6bf99945c04d89af82166fcf6e54ec1d45ab5f4d2673719f
-	Public Key PIN:
-		pin-sha256:aKORpr08YK1r+ZlFwE2Jr4IWb89uVOwdRatfTSZzcZ8=
-
-Self signature: verified
-
------BEGIN NEW CERTIFICATE REQUEST-----
-MIID7zCCAlcCAQAwWDEXMBUGA1UEAxMOcnN5c2xvZyBjbGllbnQxETAPBgNVBAsT
-CFNvbWVVbml0MRAwDgYDVQQKEwdTb21lT3JnMQswCQYDVQQIEwJDQTELMAkGA1UE
-BhMCVVMwggGiMA0GCSqGSIb3DQEBAQUAA4IBjwAwggGKAoIBgQCdkdrYLj2droXD
-xaf2pGb4yJGRuHAg3O3oI8pT97hSQ/On6/vfijsssBP6YtOhU6RRcR9o2f28OUr7
-yWrf84iEsIC8wPUbQhH2TBrYLGILXVBkMJrT28HVfzlT5L3oHgSdyRLg5FcpKQG5
-8eW8dKbnS2HmZ1xsTu7uIgwbFG3oDG/u7sO43d8V7XqWW8yF5eNQxM4rv7Y35iD8
-bkV+Cb2Eeq8HJ/SZI0HfNtgpMaCWhC/9RS7UtPn63I8jwOAGra0Kctr0O6HL1qY7
-7EbElfJxpa0IH+cGGA7bgFGWuiT2ZAJr0/B2ATQ6cgLpy9CqYlEMj4O+wEeZ0pJy
-7VOlSQXUyaH0Td4SnRrIF4TzonxnR4JLhh5zhuImJhCUo5mbCJl4nT0zXYXCRmWU
-q3C0O8EmixG2ZieIIoQDtQhFMoyBI75i3G+gql6fA/en9QNwPHgJ0IREjBmvdveT
-/K/G/dvZTMsgeURxy+ZVYal6rwujpu3pqRGv+qNdrJfn7yu2qDcCAwEAAaBSMFAG
-CSqGSIb3DQEJDjFDMEEwDAYDVR0TAQH/BAIwADAPBgNVHQ8BAf8EBQMDB6AAMCAG
-A1UdJQEB/wQWMBQGCCsGAQUFBwMCBggrBgEFBQcDATANBgkqhkiG9w0BAQsFAAOC
-AYEAZJfkv+XpjkJ84gKa0u4w5ytLj3uo6I7cWQ7UZUxp8ygXC/wrt7i1c6AGHSKj
-jVraDotZHWDSe0sRnJZFB6tk/e2vPop5C0jEQcAS5SWxE6pUnr3QDY5EU6ZoDR0V
-3sVTl6axAOsvoqu3rbsRc4cxDuAcAyRlks/BFB58xJeKTOIEWI9RXW9nRdYQq9Bp
-Jed9U0Jwe37QihIxKWmLRxYAfxvsJMuUNxcojUv3Kpsr7ixUdrz/FUQJ9qUfGXfs
-tYAFKZY2p861WlNdSJXu2ap0tJu3dJmLViF8wmLOt1PzMrcj1aqRmVjri+6X2FqQ
-tTfUD/68WvwFfW4EwxLjVrx3z5aXw7kVT+/jPgpwUkjxk9ziHg3fjs8epNs8pqLP
-8jZl9M27hF842+elf1nb1x545LWxwSMJECbaM17fQPYQRtUoS9qmyjBZQulwX5px
-byvbmhKM6yhmkssRG5UCHCKDxkZilc84L90uH4uoI9MWqCyPQ6FYwHutmZa9uadB
-GoyQ
------END NEW CERTIFICATE REQUEST-----
diff --git a/tools/omfwd.c b/tools/omfwd.c
index 4dcc1fba19..cdb74b8d22 100644
--- a/tools/omfwd.c
+++ b/tools/omfwd.c
@@ -80,6 +80,7 @@ typedef struct _instanceData {
 	uchar 	*tplName;	/* name of assigned template */
 	uchar *pszStrmDrvr;
 	uchar *pszStrmDrvrAuthMode;
+	uchar *pszStrmDrvrPermitExpiredCerts;
 	permittedPeers_t *pPermPeers;
 	int iStrmDrvrMode;
 	char	*target;
@@ -139,7 +140,8 @@ typedef struct configSettings_s {
 	uchar *pszStrmDrvr; /* name of the stream driver to use */
 	int iStrmDrvrMode; /* mode for stream driver, driver-dependent (0 mostly means plain tcp) */
 	int bResendLastOnRecon; /* should the last message be re-sent on a successful reconnect? */
-	uchar *pszStrmDrvrAuthMode; /* authentication mode to use */
+	uchar *pszStrmDrvrAuthMode;		/* authentication mode to use */
+	uchar *pszStrmDrvrPermitExpiredCerts;	/* control how to handly expired certificates */
 	int iTCPRebindInterval;	/* support for automatic re-binding (load balancers!). 0 - no rebind */
 	int iUDPRebindInterval;	/* support for automatic re-binding (load balancers!). 0 - no rebind */
 	int bKeepAlive;
@@ -395,6 +397,7 @@ BEGINfreeInstance
 CODESTARTfreeInstance
 	free(pData->pszStrmDrvr);
 	free(pData->pszStrmDrvrAuthMode);
+	free(pData->pszStrmDrvrPermitExpiredCerts);
 	free(pData->port);
 	free(pData->networkNamespace);
 	free(pData->target);
@@ -749,6 +752,11 @@ static rsRetVal TCPSendInit(void *pvData)
 		if(pData->pszStrmDrvrAuthMode != NULL) {
 			CHKiRet(netstrm.SetDrvrAuthMode(pWrkrData->pNetstrm, pData->pszStrmDrvrAuthMode));
 		}
+		if(pData->pszStrmDrvrPermitExpiredCerts != NULL) {
+			CHKiRet(netstrm.SetDrvrPermitExpiredCerts(pWrkrData->pNetstrm,
+				pData->pszStrmDrvrPermitExpiredCerts));
+		}
+
 		if(pData->pPermPeers != NULL) {
 			CHKiRet(netstrm.SetDrvrPermPeers(pWrkrData->pNetstrm, pData->pPermPeers));
 		}
@@ -1109,6 +1117,7 @@ setInstParamDefaults(instanceData *pData)
 	pData->tcp_framingDelimiter = '\n';
 	pData->pszStrmDrvr = NULL;
 	pData->pszStrmDrvrAuthMode = NULL;
+	pData->pszStrmDrvrPermitExpiredCerts = NULL;
 	pData->iStrmDrvrMode = 0;
 	pData->iRebindInterval = 0;
 	pData->bKeepAlive = 0;
@@ -1213,6 +1222,8 @@ CODESTARTnewActInst
 			pData->iStrmDrvrMode = pvals[i].val.d.n;
 		} else if(!strcmp(actpblk.descr[i].name, "streamdriverauthmode")) {
 			pData->pszStrmDrvrAuthMode = (uchar*)es_str2cstr(pvals[i].val.d.estr, NULL);
+		} else if(!strcmp(actpblk.descr[i].name, "streamdriver.permitexpiredcerts")) {
+			pData->pszStrmDrvrPermitExpiredCerts = (uchar*)es_str2cstr(pvals[i].val.d.estr, NULL);
 		} else if(!strcmp(actpblk.descr[i].name, "streamdriverpermittedpeers")) {
 			uchar *start, *str;
 			uchar *p;
